/*--------------------------------------------------------------*\
		module	:	ConfigDg.c
		purpose :	ݒ_CAO
		author	:	_@ Kengo Jinno
		create	:	1998/11/11
		update	:	1998/12/07
					2001/02/07	IDC_COMBO_DDEǉ
					2001/02/08	IDC_BTN_IMSǉ
					2001/04/20	IDC_CHECK_SEND_ALLǉ
					2001/04/20	IDC_CHECK_RICH_EDITǉ
					2001/04/23	c[`bvǉ
					2001/11/19	CreateTooltip()̈ǉɑΉ
					2014/04/04	IDC_CHECK_CLEAR_ALLǉ
					2014/04/10	HWND_BROADCASTSendMessageTimeout()
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"ConfigDg.h"

#ifdef	WIN32
#define	TB_STYLE	WS_CAPTION
#else
#define	TB_STYLE	WS_BORDER
#endif

static	void	NEAR	InitDialogProc( HWND hDlg, ConfigDlgInfo* pInfo )
{
	long	style = GetWindowLong( pInfo->hWndOwner, GWL_STYLE );
	BOOL	bTitleBar = ( ( style & TB_STYLE ) != 0 );
	NpEdLineInfo	p = GetEdLineInfo( pInfo->hWndOwner );
	CheckDlgButton( hDlg, IDC_CHECK_TITLE_BAR, bTitleBar?1:0 );
	CheckDlgButton( hDlg, IDC_CHECK_SHIFT_LOCK, p->bShiftLock?1:0 );
	CheckDlgButton( hDlg, IDC_CHECK_SEND_ALL, !p->bSendAll?1:0 );
#ifdef	WIN32
	CheckDlgButton( hDlg, IDC_CHECK_RICH_EDIT, p->bNextRichEdit?1:0 );
#else
	EnableWindow( GetDlgItem( hDlg, IDC_CHECK_RICH_EDIT ), FALSE );
#endif
	CheckDlgButton( hDlg, IDC_CHECK_CLEAR_ALL, p->bClearAll?1:0 );
	CheckDlgButton( hDlg, IDC_CHECK_RTD_DDE, p->bRtdDde?1:0 );
	EnableWindow( GetDlgItem( hDlg, IDC_BTN_WINDOW ), !p->bRtdDde );
	EnableWindow( GetDlgItem( hDlg, IDC_BTN_MESSAGE ), !p->bRtdDde );
#ifdef	IDC_COMBO_DDE
	{
		TCHAR	buff[ _MAX_PATH ];
		LPTSTR	q, r;
		/*	T[rXXgR{{bNXɓ	*/
		lstrcpy( buff, p->szServiceList );
		q = r = buff;
		while( *q != _T('\0') ) {
			if( *q == _T(';') ) {
				*q = _T('\0');
				SendDlgItemMessage( hDlg, IDC_COMBO_DDE, CB_ADDSTRING, 0, (LPARAM)r );
				r = q+1;
			}
			q++;
		}
		SendDlgItemMessage( hDlg, IDC_COMBO_DDE, CB_ADDSTRING, 0, (LPARAM)r );
		SendDlgItemMessage( hDlg, IDC_COMBO_DDE, CB_LIMITTEXT, _MAX_FNAME, 0 );
		SetWindowText( GetDlgItem( hDlg, IDC_COMBO_DDE ), p->szServerName );
	}
	EnableWindow( GetDlgItem( hDlg, IDC_COMBO_DDE ), p->bRtdDde );
#endif
#ifdef	IDC_BTN_IMS
#ifdef	WIN32
	pInfo->bImsSearching = FALSE;
	pInfo->nImsStatus = IMS_STAT_NONE;
	pInfo->uApiMessage = RegisterWindowMessage( IMS_API_MESSAGE_STRING );
	pInfo->hWndIms = NULL;
	pInfo->hWndTts = NULL;
	LoadString( p->hInstance, IDS_TTS_WND_CLASS, pInfo->szTtsWndClass, _MAX_PATH );
	LoadString( p->hInstance, IDS_TTS_EDIT_CLASS, pInfo->szTtsEditClass, _MAX_PATH );
	LoadString( p->hInstance, IDS_IMS_WND_CLASS, pInfo->szImsWndClass, _MAX_PATH );
#else	/*	16bitłł͖	*/
	EnableWindow( GetDlgItem( hDlg, IDC_BTN_IMS ), FALSE );
#endif
#endif
	{
		HWND	hButton = p->hWndButton;
		RECT	rect, rect2;
		int		sx, sy;
		/*	_CAO{^̈ʒuɈړ	*/
		GetWindowRect( hButton, &rect2 );
		GetWindowRect( hDlg, &rect );
		rect2.left -= ( rect.right - rect.left - ( rect2.right - rect2.left ) ) / 2;	//	Z^O
		OffsetRect( &rect, rect2.left-rect.left, rect2.bottom-rect.top );
		/*	ʂ͂ݏoȂ悤ɐ	*/
		sx = GetSystemMetrics( SM_CXSCREEN );
		sy = GetSystemMetrics( SM_CYSCREEN );
		if( rect.left < 0 )			OffsetRect( &rect, 0-rect.left, 0 );
		if( rect.right >= sx )		OffsetRect( &rect, sx-1-rect.right, 0 );
		if( rect.top < 0 )			OffsetRect( &rect, 0, 0-rect.top );
		if( rect.bottom >= sy )		OffsetRect( &rect, 0, sy-1-rect.bottom );
		MoveWindow( hDlg, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top, FALSE );
		/*
			Windows95Ɩ{́A^XNo[̑傫ƂlȂƂȂB
			ɁAzʂgĂ肵ꍇɁAł̂H
		*/
	}
#ifdef	WIN32
	{	/*	c[`bv	*/
		TooltipInfo	ti[] = {
			{ IDC_BTN_WINDOW,       IDS_TIPS_BTN_WINDOW       },
			{ IDC_BTN_MESSAGE,      IDS_TIPS_BTN_MESSAGE      },
			{ IDC_BTN_FONT,         IDS_TIPS_BTN_FONT         },
			{ IDC_BTN_IMS,          IDS_TIPS_BTN_IMS          },
			{ IDC_CHECK_TITLE_BAR,  IDS_TIPS_CHECK_TITLE_BAR  },
			{ IDC_CHECK_SHIFT_LOCK, IDS_TIPS_CHECK_SHIFT_LOCK },
			{ IDC_CHECK_SEND_ALL,   IDS_TIPS_CHECK_SEND_ALL   },
			{ IDC_CHECK_RICH_EDIT,  IDS_TIPS_CHECK_RICH_EDIT  },
			{ IDC_CHECK_RTD_DDE,    IDS_TIPS_CHECK_RTD_DDE    },
			{ IDC_COMBO_DDE,        IDS_TIPS_COMBO_DDE        },
			{ IDCANCEL,             IDS_TIPS_CANCEL           },
			{ IDC_CHECK_CLEAR_ALL,  IDS_TIPS_CHECK_CLEAR_ALL  },
		};
		int		nCnt = sizeof(ti) / sizeof(TooltipInfo);
		pInfo->hWndTooltip = CreateTooltip( hDlg, ti, nCnt, p->bMultilineTip, p->bBalloonTip, TRUE );
	}
#endif
}

#if	defined(IDC_BTN_IMS) && defined(WIN32)
/*	EBhENXIMSTĂ݂	*/
BOOL	CALLBACK	EnumImsWndProc( HWND hWnd, LPARAM lParam )
{
	ConfigDlgInfo*	pInfo = (ConfigDlgInfo*)lParam;
	
	if( pInfo != NULL ) {
		TCHAR	szClassName[_MAX_PATH];
		
		GetClassName( hWnd, szClassName, _MAX_PATH );
		
		if( lstrcmp( szClassName, pInfo->szImsWndClass ) == 0 ) {	//	"ImServerWndClass"
			pInfo->hWndIms = hWnd;
			return FALSE;
		}
	}
	return TRUE;
}

/*	IMST	*/
static	void	NEAR	SearchImsProc( HWND hDlg, ConfigDlgInfo* pInfo )
{
	NpEdLineInfo	p = GetEdLineInfo( pInfo->hWndOwner );
	DWORD	dwResult;
	
	pInfo->hWndIms = NULL;
	pInfo->hWndTts = NULL;
	pInfo->bImsSearching = TRUE;
	pInfo->nImsStatus = IMS_STAT_NONE;
	
	/*	u[hLXg	*/
//	SendMessage( HWND_BROADCAST, pInfo->uApiMessage, IMS_API_SEARCH_SERVER, (LPARAM)hDlg );
	SendMessageTimeout( HWND_BROADCAST, pInfo->uApiMessage, IMS_API_SEARCH_SERVER, (LPARAM)hDlg, SMTO_ABORTIFHUNG, 2000, &dwResult );
	pInfo->bImsSearching = FALSE;
	
	if( pInfo->nImsStatus == IMS_STAT_NONE || pInfo->hWndIms == NULL || !IsWindow( pInfo->hWndIms ) ) {
		/*	ȂBÂo[WȂׂB	*/
		TCHAR	msg[_MAX_PATH];
		pInfo->hWndIms = NULL;
		EnumWindows( EnumImsWndProc, (LPARAM)pInfo );
		if( pInfo->hWndIms == NULL ) {
			/*	{ɂȂ炵B	*/
			LoadString( p->hInstance, IDS_ERR_NO_IMS, msg, _MAX_PATH );
		} else {
			/*	ԂAÂo[W	*/
			LoadString( p->hInstance, IDS_ERR_OLD_IMS, msg, _MAX_PATH );
		}
		MessageBox( hDlg, msg, p->szAppname, MB_ICONSTOP );
	} else if( pInfo->nImsStatus == IMS_STAT_OTHER ) {
		/*	󂫂	*/
		TCHAR	msg[_MAX_PATH], msg2[_MAX_PATH];
		LoadString( p->hInstance, IDS_ERR_OTHER, msg2, _MAX_PATH );
		wsprintf( msg, msg2, p->szAppname );
		MessageBox( hDlg, msg, p->szAppname, MB_ICONSTOP );
	} else if( pInfo->nImsStatus == IMS_STAT_DONE ) {
		/*	łɃj^[Ă	*/
		TCHAR	msg[_MAX_PATH];
		LoadString( p->hInstance, IDS_OK_DONE, msg, _MAX_PATH );
		MessageBox( hDlg, msg, p->szAppname, MB_ICONINFORMATION );
	} else if( pInfo->nImsStatus == IMS_STAT_TTS ) {
		/*	TTSj^[ĂB؂ւ邩₢킹B	*/
		TCHAR	msg[_MAX_PATH], msg2[_MAX_PATH];
		int		nRet;
		LoadString( p->hInstance, IDS_ERR_IMS_TTS, msg2, _MAX_PATH );
		wsprintf( msg, msg2, p->szAppname );
		nRet = MessageBox( hDlg, msg, p->szAppname, MB_ICONEXCLAMATION|MB_YESNO );
		if( nRet == IDYES ) {
			/*	؂ւāAmF	*/
			SendMessage( pInfo->hWndIms, pInfo->uApiMessage, IMS_API_SET_MONITOR, (LPARAM)p->hWndEdit );
			PostMessage( hDlg, WM_IMSHCA_EXECUTE, EXE_START_IMS, 0 );
		}
	} else {
		/*	OKBmF	*/
		PostMessage( hDlg, WM_IMSHCA_EXECUTE, EXE_START_IMS, 0 );
	}
}

/*	IMS_API_SEARCH_SERVER ̃u[hLXgɑ΂鉞	*/
static	void	NEAR	ImsAckServerProc( HWND hDlg, HWND hWndServer, ConfigDlgInfo* pInfo )
{
	NpEdLineInfo	p = GetEdLineInfo( pInfo->hWndOwner );
	
	if( pInfo->bImsSearching && !( pInfo->nImsStatus == IMS_STAT_OK || pInfo->nImsStatus == IMS_STAT_DONE ) ) {
		HWND	hWndMonitor;	/*	̃T[o[j^[ĂEBhE	*/
		
		/*	fbhbNh~	*/
		if( InSendMessage() ) {
			ReplyMessage( 0 );
		}
		
		/*	j^[H	*/
		hWndMonitor = (HWND)SendMessage( hWndServer, pInfo->uApiMessage, IMS_API_GET_MONITOR, 0 );
		if( hWndMonitor == NULL ) {
			/*	󂢂Ă̂ŁAEdLinE̓̓EBhEݒ	*/
			SendMessage( hWndServer, pInfo->uApiMessage, IMS_API_SET_MONITOR, (LPARAM)p->hWndEdit );
			pInfo->nImsStatus = IMS_STAT_OK;
			pInfo->hWndIms = hWndServer;
		} else if( hWndMonitor == p->hWndEdit ) {
			/*	j^[w肳Ă	*/
			pInfo->nImsStatus = IMS_STAT_DONE;
			pInfo->hWndIms = hWndServer;
		} else if( pInfo->nImsStatus != IMS_STAT_TTS ) {
			/*	TTSH	*/
			TCHAR	szClassName[_MAX_PATH];
			GetClassName( hWndMonitor, szClassName, _MAX_PATH );
			if( lstrcmpi( szClassName, pInfo->szTtsEditClass ) == 0 ) {	//	"EDIT"
				/*	ẽNXmF	*/
				HWND	hWndParent = GetParent( hWndMonitor );
				if( hWndParent != NULL && IsWindow( hWndParent ) ) {
					GetClassName( hWndParent, szClassName, _MAX_PATH );
					if( lstrcmp( szClassName, pInfo->szTtsWndClass ) == 0 ) {	//	"TTSWndClass"
						pInfo->hWndTts = hWndParent;
						pInfo->nImsStatus = IMS_STAT_TTS;
						pInfo->hWndIms = hWndServer;
					}
				}
			}
		}
		/*	ȂƂ͌(gȂ)	*/
		if( pInfo->nImsStatus == IMS_STAT_NONE ) {
			pInfo->nImsStatus = IMS_STAT_OTHER;
			pInfo->hWndIms = hWndServer;
		}
	}
}

/*	JnłmF	*/
static	void	NEAR	StartImsProc( HWND hDlg, ConfigDlgInfo* pInfo )
{
	NpEdLineInfo	p = GetEdLineInfo( pInfo->hWndOwner );
	HWND	hWndMonitor = NULL;
	
	/*	Ɛݒ肳Ă邩H	*/
	if( pInfo->hWndIms != NULL && IsWindow( pInfo->hWndIms ) ) {
		hWndMonitor = (HWND)SendMessage( pInfo->hWndIms, pInfo->uApiMessage, IMS_API_GET_MONITOR, 0 );
	}
	if( hWndMonitor == p->hWndEdit ) {
		TCHAR	msg[_MAX_PATH], msg2[_MAX_PATH];
		/*	OKȂ̂ŃX^[g	*/
		SendMessage( pInfo->hWndIms, pInfo->uApiMessage, IMS_API_START_SERVICE, 0 );
		LoadString( p->hInstance, IDS_OK, msg2, _MAX_PATH );
		wsprintf( msg, msg2, p->szAppname );
		MessageBox( hDlg, msg, p->szAppname, MB_ICONINFORMATION );
	} else {
		/*	m̃G[	*/
		TCHAR	msg[_MAX_PATH];
		LoadString( p->hInstance, IDS_ERR_UNKNOWN, msg, _MAX_PATH );
		MessageBox( hDlg, msg, p->szAppname, MB_ICONSTOP );
	}
}
#endif

BOOL	CALLBACK	ConfigDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	WORD	wNotifyCode, wID;
	HWND	hWndCtrl;
	switch( uMsg ) {
	case WM_INITDIALOG:
		InitDialogProc( hDlg, (ConfigDlgInfo*)lParam );
		SetWindowLong( hDlg, DWL_USER, (long)lParam );
		return TRUE;
	case WM_COMMAND:
#ifdef	WIN32
		wNotifyCode = HIWORD(wParam);
		wID = LOWORD(wParam);
		hWndCtrl = (HWND)lParam;
#else
		wNotifyCode = HIWORD(lParam);
		wID = wParam;
		hWndCtrl = (HWND)LOWORD(lParam);
#endif
		if( wNotifyCode == BN_CLICKED ) {
			ConfigDlgInfo*	pInfo = (ConfigDlgInfo*)GetWindowLong( hDlg, DWL_USER );
			NpEdLineInfo	p = GetEdLineInfo( pInfo->hWndOwner );
			if( wID == IDC_BTN_WINDOW ) {
				p->lpEdsInitWindowDialog( hDlg, &(p->hWndTarget) );
			} else if( wID == IDC_BTN_MESSAGE ) {
				p->lpEdsInitParamDialog( hDlg, &(p->EdsParam) );
			} else if( wID == IDC_BTN_FONT ) {
				CHOOSEFONT	cf;
				LOGFONT		lf;
				lf = p->lfText;
				cf.lStructSize = sizeof(cf);
				cf.hwndOwner = hDlg;
				cf.hDC = NULL;
				cf.lpLogFont = &lf;
				cf.iPointSize = 0;
				cf.Flags = CF_INITTOLOGFONTSTRUCT|CF_SCREENFONTS;
#ifdef	WIN32
				cf.Flags |= CF_ANSIONLY|CF_NOVERTFONTS;
#endif
				cf.rgbColors = 0;
				cf.lCustData = 0;
				cf.lpfnHook = NULL;
				cf.lpTemplateName = NULL;
				cf.hInstance = NULL;
				cf.lpszStyle = NULL;
				cf.nFontType = 0;
				cf.nSizeMin = cf.nSizeMax = 0;
				if( ChooseFont( &cf ) ) {
					RECT	rect;
					LPARAM	lParam;
					/*	tHgč\z	*/
					p->lfText = lf;
					if( p->hFont != NULL ) {
						DeleteObject( p->hFont );
					}
					p->hFont = CreateFontIndirect( &(p->lfText) );
					SendMessage( p->hWndEdit, WM_SETFONT, (WPARAM)p->hFont, TRUE );
					/*	eWM_SIZEbZ[W𑗂āAEBhETCYČvZ	*/
					GetWindowRect( pInfo->hWndOwner, &rect );
					lParam = MAKELPARAM( rect.right-rect.left, rect.bottom-rect.top );
					SendMessage( pInfo->hWndOwner, WM_SIZE, SIZE_RESTORED, lParam );
				}
				return TRUE;
			} else if( wID == IDC_CHECK_TITLE_BAR ) {
				BOOL	bTitleBar = ( IsDlgButtonChecked( hDlg, IDC_CHECK_TITLE_BAR ) == 1 );
				long	style = GetWindowLong( pInfo->hWndOwner, GWL_STYLE );
				if( bTitleBar ) {
					style |= TB_STYLE;
				} else {
					style &= ~TB_STYLE;
				}
				SetWindowLong( pInfo->hWndOwner, GWL_STYLE, style );
				DrawMenuBar( pInfo->hWndOwner );
			} else if( wID == IDC_CHECK_SHIFT_LOCK ) {
				p->bShiftLock = ( IsDlgButtonChecked( hDlg, IDC_CHECK_SHIFT_LOCK ) == 1 );
			} else if( wID == IDC_CHECK_SEND_ALL ) {
				p->bSendAll = !( IsDlgButtonChecked( hDlg, IDC_CHECK_SEND_ALL ) == 1 );
#ifdef	WIN32
			} else if( wID == IDC_CHECK_RICH_EDIT ) {
				p->bNextRichEdit = ( IsDlgButtonChecked( hDlg, IDC_CHECK_RICH_EDIT ) == 1 );
				if( p->bNextRichEdit != p->bRichEdit ) {
					TCHAR	msg[_MAX_PATH];
					LoadString( p->hInstance, IDS_MSG_RICH_EDIT, msg, _MAX_PATH );
					MessageBox( hDlg, msg, p->szAppname, MB_ICONEXCLAMATION );
				}
#endif
			} else if( wID == IDC_CHECK_CLEAR_ALL ) {
				p->bClearAll = ( IsDlgButtonChecked( hDlg, IDC_CHECK_CLEAR_ALL ) == 1 );
			} else if( wID == IDC_CHECK_RTD_DDE ) {
				p->bRtdDde = ( IsDlgButtonChecked( hDlg, IDC_CHECK_RTD_DDE ) == 1 );
				EnableWindow( GetDlgItem( hDlg, IDC_BTN_WINDOW ), !p->bRtdDde );
				EnableWindow( GetDlgItem( hDlg, IDC_BTN_MESSAGE ), !p->bRtdDde );
#ifdef	IDC_COMBO_DDE
				EnableWindow( GetDlgItem( hDlg, IDC_COMBO_DDE ), p->bRtdDde );
#endif
			} else if( wID == IDCANCEL ) {
#ifdef	IDC_COMBO_DDE
				if( p->bRtdDde ) {
					GetWindowText( GetDlgItem( hDlg, IDC_COMBO_DDE ), p->szServerName, _MAX_FNAME );
				}
#endif
				EndDialog( hDlg, IDOK );
				return TRUE;
#if	defined(IDC_BTN_IMS) && defined(WIN32)
			} else if( wID == IDC_BTN_IMS ) {
				PostMessage( hDlg, WM_IMSHCA_EXECUTE, EXE_SEARCH_IMS, 0 );
#endif
			}
		}
		break;
#ifdef	WIN32
	case WM_DESTROY:
		{
			ConfigDlgInfo*	pInfo = (ConfigDlgInfo*)GetWindowLong( hDlg, DWL_USER );
			if( pInfo != NULL ) {
				/*	c[`bv폜	*/
				DestroyTooltip( pInfo->hWndTooltip );
			}
		}
		break;
#endif
#if	defined(IDC_BTN_IMS) && defined(WIN32)
	case WM_IMSHCA_EXECUTE:
		{
			ConfigDlgInfo*	pInfo = (ConfigDlgInfo*)GetWindowLong( hDlg, DWL_USER );
			switch( wParam ) {
			case EXE_SEARCH_IMS:
				SearchImsProc( hDlg, pInfo );
				break;
			case EXE_START_IMS:
				StartImsProc( hDlg, pInfo );
				break;
			}
		}
		break;
	default:
		{
			ConfigDlgInfo*	pInfo = (ConfigDlgInfo*)GetWindowLong( hDlg, DWL_USER );
			if( pInfo != NULL && pInfo->uApiMessage == uMsg && wParam == IMS_API_ACK_SERVER ) {
				/*	u[hLXgIMS	*/
				ImsAckServerProc( hDlg, (HWND)lParam, pInfo );
			}
		}
		break;
#endif
	}
	return FALSE;
}
