/*--------------------------------------------------------------*\
		module	:	MyDDE.c
		purpose :	PsҏW DDENCAg
		author	:	_@ Kengo Jinno
		create	:	1998/12/07
		update	:	1998/12/08
					2001/02/07	t@CύX
					2001/11/19	SendDDEString()wsprintf()
								gȂB
					2001/11/19	WM_DDE_EXECUTEWM_DDE_TERMINATE
								T[o[ł10bŃ^CAEg
					2001/11/19	WM_DDE_INITIATESendMessageTimeout()
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"MyDDE.h"

/*	WM_DDE_ACK	*/
BOOL	DdeAckProc( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	
	if( p == NULL ) {
		return FALSE;
	} else if( p->nClientStatus == DDE_STAT_INITIATE ) {	//	WM_DDE_INITIATE
		p->hWndServer = (HWND)wParam;
		p->nClientStatus = DDE_STAT_IDLE;
		return TRUE;
	} else if( p->nClientStatus == DDE_STAT_EXECUTE ) {		//	WM_DDE_EXECUTE
		HWND	hWndServer = (HWND)wParam;
		HGLOBAL	hCmd;
#ifdef	WIN32
		UINT	uLow;
		UnpackDDElParam( WM_DDE_ACK, lParam, &uLow, (UINT*)&hCmd );
#else
		hCmd = (HGLOBAL)HIWORD( lParam );
#endif
		GlobalFree( hCmd );
#ifdef	WIN32
		FreeDDElParam( WM_DDE_ACK, lParam );
#endif
		p->nClientStatus = DDE_STAT_IDLE;
		return TRUE;
	}
	
	return FALSE;
}

/*	WM_DDE_TERMINATE	*/
BOOL	DdeTerminateProc( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	
	if( p == NULL ) {
		return FALSE;
	}
	switch( p->nClientStatus ) {
	case DDE_STAT_IDLE:				/*	T[o[TerminateĂ	*/
		PostMessage( (HWND)wParam, WM_DDE_TERMINATE, (WPARAM)hWnd, 0 );
		/*	̂܂ܗ	*/
	case DDE_STAT_TERMINATE:		/*	TerminatevɃT[o[Ԏ	*/
		p->nClientStatus = DDE_STAT_NONE;
		p->hWndServer = NULL;
		break;
	}
	return TRUE;
}


BOOL	InitiateDDE( HWND hWnd )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	
	if( p != NULL && p->nClientStatus == DDE_STAT_NONE ) {
		ATOM	aApp, aTopic;
		LPARAM	lParam;
		static	const	TCHAR	BASED_CODE	szTopicName[] = _T("Command");
#ifdef	WIN32
		DWORD	dwResult;
#endif
		
		aApp = GlobalAddAtom( p->szServerName );
		aTopic = GlobalAddAtom( szTopicName );
		lParam = MAKELPARAM( aApp, aTopic );
		p->nClientStatus = DDE_STAT_INITIATE;
#ifdef	WIN32
		SendMessageTimeout( HWND_BROADCAST, WM_DDE_INITIATE, (WPARAM)hWnd, lParam, SMTO_ABORTIFHUNG, 300, &dwResult );
#else
		SendMessage( HWND_BROADCAST, WM_DDE_INITIATE, (WPARAM)hWnd, lParam );
#endif
		GlobalDeleteAtom( aApp );
		GlobalDeleteAtom( aTopic );
		if( p->nClientStatus != DDE_STAT_IDLE ) {
			p->nClientStatus = DDE_STAT_NONE;
		}
	}
	
	return TRUE;
}

/*	`bN̍߂	*/
static	DWORD	GetTickDiff( DWORD dwTo, DWORD dwFrom )
{
	if( dwTo < dwFrom ) {
		/*	t]Ă遁JE^I[o[t[	*/
		return( dwTo + ~dwFrom + 1 );
	}
	return( dwTo - dwFrom );
}

BOOL	SendDDEString( HWND hWnd, LPCTSTR lpszText )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	
	if( p == NULL ) {
		return FALSE;
	}
	InitiateDDE( hWnd );
	if( p->nClientStatus != DDE_STAT_IDLE || p->hWndServer == NULL || !IsWindow( p->hWndServer ) ) {
		return FALSE;
	} else {
		static	const	TCHAR	BASED_CODE	lpszFormat[] = _T("[Send(@)]");
		TCHAR	cSep = _T('@');
		int		nLen = lstrlen( lpszText ) + lstrlen( lpszFormat );
		HGLOBAL	hGlobal = GlobalAlloc( GMEM_MOVEABLE|GMEM_DDESHARE|GMEM_ZEROINIT, (nLen+1)*sizeof(TCHAR) );
		LPTSTR	lpszGlobal = GlobalLock( hGlobal );
		LPARAM	lParam;
		
		/*
			wsprintf()1024byte̐̂ŎgȂB
			ǂrɕ𖄂ߍނȂ̂ŁAOłB
		*/
		{
			LPTSTR	p;
			LPCTSTR	q, r;
			p = lpszGlobal;		//	Rs[
			q = lpszFormat;		//	tH[}bg
			r = lpszText;		//	p[^
			while( *q != _T('\0') ) {
				if( *q == cSep ) {
					//	Zp[^Ƀp[^̕}
					while( *r != _T('\0') ) {
						*(p++) = *(r++);
					}
					q++;
				} else {
					*(p++) = *(q++);
				}
			}
			*p = _T('\0');
		}
		GlobalUnlock( hGlobal );
#ifdef	WIN32
		lParam = PackDDElParam( WM_DDE_EXECUTE, 0, (UINT)hGlobal );
#else
		lParam = MAKELPARAM( 0, hGlobal );
#endif
		p->nClientStatus = DDE_STAT_EXECUTE;
		if( !PostMessage( p->hWndServer, WM_DDE_EXECUTE, (WPARAM)hWnd, lParam ) ) {
			p->nClientStatus = DDE_STAT_IDLE;
			GlobalFree( hGlobal );
#ifdef	WIN32
			FreeDDElParam( WM_DDE_EXECUTE, lParam );
#endif
		} else {
			MSG	msg;
			DWORD	dwTick = GetTickCount();
			while( p->nClientStatus == DDE_STAT_EXECUTE ) {
				if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
					DoMessage( hWnd, &msg );
				}
				if( GetTickDiff( GetTickCount(), dwTick ) > 10000 ) {
					p->nClientStatus = DDE_STAT_IDLE;
					break;
				}
			}
		}
	}
	
	return TRUE;
}

BOOL	TerminateDDE( HWND hWnd )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	if( p != NULL && p->nClientStatus == DDE_STAT_IDLE ) {
		p->nClientStatus = DDE_STAT_TERMINATE;
		if( PostMessage( p->hWndServer, WM_DDE_TERMINATE, (WPARAM)hWnd, 0 ) ) {
			MSG	msg;
			DWORD	dwTick = GetTickCount();
			while( p->nClientStatus == DDE_STAT_TERMINATE ) {
				if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
					DoMessage( hWnd, &msg );
				}
				if( GetTickDiff( GetTickCount(), dwTick ) > 10000 ) {
					p->nClientStatus = DDE_STAT_NONE;
					break;
				}
			}
		}
	}
	
	return TRUE;
}
