/*--------------------------------------------------------------*\
		module	:	Tooltip.c
		purpose :	c[`bv
		author	:	_@ Kengo Jinno
		create	:	2001/04/20
		update	:	2001/04/23
					2001/11/19	TTS_BALLOONɐĂoOC
					2001/11/19	TTS_BALLOONWS_EX_TOPMOSTO
					2001/11/19	CreateTooltip()ɈbSubclassǉ
					2001/11/19	COMBO̎qłEDITł\悤
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"Tooltip.h"

#ifdef	WIN32

extern	BOOL	NEAR	ScreenToClientRect( HWND hWnd, LPRECT lprect );

static	LPCTSTR		lpszPropertyName = _T("MyToolTipProperty");

#ifndef	TTS_BALLOON
#define	TTS_BALLOON	0x40
#endif

static	LRESULT	CALLBACK	MyToolTipWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	WNDPROC	lpfnOldWndProc = (WNDPROC)GetProp( hWnd, lpszPropertyName );
	if( lpfnOldWndProc == NULL ) {
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}
	if( uMsg == WM_WINDOWPOSCHANGING ) {
		LPWINDOWPOS	lpwp = (LPWINDOWPOS)lParam;
		if( lpwp != NULL && !( lpwp->flags & SWP_NOMOVE ) ) {
			RECT	rect;
			POINT	point;
			GetWindowRect( hWnd, &rect );
			OffsetRect( &rect, lpwp->x - rect.left, lpwp->y - rect.top );
			if( !( lpwp->flags & SWP_NOSIZE ) ) {
				rect.right = rect.left + lpwp->cx;
				rect.bottom = rect.top + lpwp->cy;
			}
			GetCursorPos( &point );
			if( PtInRect( &rect, point ) ) {
				/*	߂֓	*/
				long	xl, xr, xm, yt, yb, ym;
				xl = point.x - rect.left + 1;
				xr = rect.right - point.x;
				xm = ( xl <= xr ) ? xl : -xr;
				yt = point.y - rect.top + 1;
				yb = rect.bottom - point.y;
				ym = ( yt <= yb ) ? yt : -yb;
				if( ( xm < 0 ? -xm : xm ) <= ( ym < 0 ? -ym : ym ) ) {
					lpwp->x += xm;
				} else {
					lpwp->y += ym;
				}
			}
		}
	} else if( uMsg == WM_DESTROY ) {
		RemoveProp( hWnd, lpszPropertyName );
	}
	return CallWindowProc( lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
}

HWND	CreateTooltip( HWND hParent, const FpTooltipInfo pInfo, int nInfoCnt, BOOL bMultiline, BOOL bBalloon, BOOL bSubclass )
{
	HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hParent, GWL_HINSTANCE );
	HWND		hWnd;
	WNDPROC		lpfnOldWndProc;
	
	hWnd = CreateWindowEx( bBalloon?0:WS_EX_TOPMOST, TOOLTIPS_CLASS, NULL,
		WS_POPUP/*|TTS_ALWAYSTIP*/|(bBalloon?TTS_BALLOON:0),
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		hParent, NULL, hInstance, NULL );
		/*
			TTS_ALWAYSTIPtƂH@łזH
			WS_EX_TOPMOST́AIMẼc[o[Oɏo߂ɕKvB
		*/
	if( hWnd != NULL ) {
		TOOLINFO	ti;
		int			i;
		
		/*	eRg[ɃeLXg蓖Ă	*/
		ZeroMemory( &ti, sizeof(ti) );
		ti.cbSize = sizeof(ti);
		ti.hwnd = hParent;
		ti.hinst = hInstance;
		for( i = 0; i < nInfoCnt; i++ ) {
			if( bMultiline ) {
				ti.lpszText = (LPTSTR)MAKEINTRESOURCE( pInfo[i].iStringID + 16 );
				/*	spID = PspID + 16 Ƃ邱ƁB	*/
			} else {
				ti.lpszText = (LPTSTR)MAKEINTRESOURCE( pInfo[i].iStringID );
			}
			if( pInfo[i].iWndID == 0 ) {
				ti.uId = (UINT)hParent;
				ti.uFlags = bSubclass?TTF_SUBCLASS:0;
				SetRectEmpty( &(ti.rect) );
				ti.rect.right = GetSystemMetrics(SM_CXSCREEN);
				ti.rect.bottom = GetSystemMetrics(SM_CYSCREEN);
				SendMessage( hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti );
			} else {
				HWND	hWndTool = GetDlgItem( hParent, pInfo[i].iWndID );
				ti.uId = (UINT)hWndTool;
				SetRectEmpty( &(ti.rect) );
				ti.uFlags = TTF_IDISHWND|(bSubclass?TTF_SUBCLASS:0);
				SendMessage( hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti );
#if 1
				{
					HWND	hWndChild;
					hWndChild = GetWindow( hWndTool, GW_CHILD );
					while( hWndChild != NULL ) {
						ti.uId = (UINT)hWndChild;
						if( bMultiline ) {
							/*	eɑĂ܂̂ŁACALLBACKȂB	*/
							/*	܂A80ȓłȂƂȂB	*/
							ti.lpszText = (LPTSTR)MAKEINTRESOURCE( pInfo[i].iStringID + 16 );
						}
						SendMessage( hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti );
						hWndChild = GetWindow( hWndChild, GW_HWNDNEXT );
					}
				}
#endif
				/*	ȃRg[̑΍(2001/04/13)	*/
				GetWindowRect( hWndTool, &(ti.rect) );
				ScreenToClientRect( hParent, &(ti.rect) );
				ti.uFlags = bSubclass?TTF_SUBCLASS:0;
				SendMessage( hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti );
			}
		}
		if( bMultiline ) {
			int		nTime;
			/*	sBIE3(4.70)ȍ~	*/
			SendMessage( hWnd, TTM_SETMAXTIPWIDTH, 0, GetSystemMetrics(SM_CXSCREEN) );
			/*	\Ԃ𒷂BIE3(4.70)ȍ~	*/
			nTime = SendMessage( hWnd, TTM_GETDELAYTIME, TTDT_AUTOPOP, 0 );
			if( nTime > 0 ) {
				nTime *= 3;		/*	3{	*/
				SendMessage( hWnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, nTime );
			}
			/*	ԂWIł́ATbPTbɂȂ͂B	*/
		}
		/*
			TTF_SUBCLASStĂ΁AbZ[W[v
			TTM_RELAYEVENTKv͂ȂB
		*/
		SendMessage( hWnd, TTM_ACTIVATE, TRUE, 0 );
		/*	TuNX	*/
		lpfnOldWndProc = (WNDPROC)SetWindowLong( hWnd, GWL_WNDPROC, (LONG)MyToolTipWndProc );
		/*	vpeBɂZbg	*/
		SetProp( hWnd, lpszPropertyName, (HANDLE)lpfnOldWndProc );
		return hWnd;
	}
	return NULL;
}

void	DestroyTooltip( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		WNDPROC	lpfnOldWndProc = (WNDPROC)GetProp( hWnd, lpszPropertyName );
		/*	TuNX	*/
		if( lpfnOldWndProc != NULL ) {
			SetWindowLong( hWnd, GWL_WNDPROC, (LONG)lpfnOldWndProc );
		}
		/*	vpeB폜	*/
		RemoveProp( hWnd, lpszPropertyName );
		/*	p	*/
		DestroyWindow( hWnd );
	}
}

BOOL	GetDllVersion( LPCTSTR lpszDllName, LPDWORD lpdwFileMS, LPDWORD lpdwFileLS, LPDWORD lpdwProdMS, LPDWORD lpdwProdLS )
{
	BOOL	ret = TRUE;
	HINSTANCE	hInstDll = LoadLibrary( lpszDllName );
	if( hInstDll == NULL ) {
		ret = FALSE;
	} else {
		TCHAR	szPath[_MAX_PATH];
		DWORD	dwInfoSize;
		LPVOID	lpBlock = NULL;
		VS_FIXEDFILEINFO	*lpInfo;
		
		if( ret ) {
			ret = ( GetModuleFileName( hInstDll, szPath, _MAX_PATH ) != 0 );
		}
		if( ret ) {
			dwInfoSize = GetFileVersionInfoSize( szPath, NULL );
			ret = ( dwInfoSize != 0 );
		}
		if( ret ) {
			lpBlock = (LPVOID)GlobalAlloc( GPTR, sizeof(BYTE)*dwInfoSize );
			ret = ( lpBlock != NULL );
		}
		if( ret ) {
			ret = GetFileVersionInfo( szPath, 0, dwInfoSize, lpBlock );
		}
		if( ret ) {
			UINT	uLen;
			ret = VerQueryValue( lpBlock, _T("\\"), (LPVOID*)&lpInfo, &uLen );
		}
		if( ret ) {
			if( lpdwFileMS != NULL )	*lpdwFileMS = lpInfo->dwFileVersionMS;
			if( lpdwFileLS != NULL )	*lpdwFileLS = lpInfo->dwFileVersionLS;
			if( lpdwProdMS != NULL )	*lpdwProdMS = lpInfo->dwProductVersionMS;
			if( lpdwProdLS != NULL )	*lpdwProdLS = lpInfo->dwProductVersionLS;
		}
		if( lpBlock != NULL ) {
			GlobalFree( (HGLOBAL)lpBlock );
		}
		FreeLibrary( hInstDll );
	}
	return ret;
}

void	RelayEventTooltip( HWND hWnd, LPMSG lpmsg )
{
	if( IsWindow( hWnd ) && lpmsg != NULL ) {
		if( lpmsg->message >= WM_MOUSEFIRST && lpmsg->message <= WM_MOUSELAST ) {
			SendMessage( hWnd, TTM_RELAYEVENT, 0, (LPARAM)lpmsg );
		}
	}
}
#endif	/*	WIN32	*/
