# edline.mak : Builds the edline application
#
# Usage:     NMAKE option (build edline)
#    or:     NMAKE clean  (erase all compiled files)
#
# option:    DEBUG=[0|1]  (DEBUG not defined is equivalent to DEBUG=1)

# for Windows 3.1
WINVER=0x030a
# for Windows 3.0
#WINVER=0x0300

CPPFLAGS=/AL /GEf /GA /G2 /W3 /DWINVER=$(WINVER)
LINKFLAGS=/STACK:10240 /ALIGN:16 /NOD /ONERROR:NOEXE /PACKC:61440

EXE=edline.exe

!if "$(DEBUG)" != "0"
CPPFLAGS=/nologo /D_DEBUG $(CPPFLAGS) /Od /Zi /Fdedline.pdb
LINKFLAGS=$(LINKFLAGS) /CODEVIEW
LIBS=llibcew 
RCDEFS=/D_DEBUG /DWIN16
!else
CPPFLAGS=/nologo /DNDEBUG $(CPPFLAGS) /O1
LINKFLAGS=$(LINKFLAGS)
LIBS=llibcew 
RCDEFS=/DNDEBUG /DWIN16
!endif

CFLAGS=$(CPPFLAGS) /Yupch.h
LIBS=$(LIBS) libw commdlg shell mmsystem ddeml winnls

#############################################################################
# file list

OBJS=pch.obj edline.obj configdg.obj mydde.obj

#############################################################################
# Final linking

$(EXE): $(OBJS) edline.def edline.res
	link @<<
$(OBJS)
$(EXE)
edline.map/MAP
$(LIBS)
edline.def $(LINKFLAGS)
;
<<
!if "$(WINVER)" != "0x0300"
	rc /31 /t edline.res $(EXE)
!else
	rc /30 /t edline.res $(EXE)
!endif
	mapsym edline.map

#############################################################################
# Compiling resources

edline.res: resource.h edline.rc
	rc /r /z $(RCDEFS) edline.rc

#############################################################################
# Special rules

# 'stdafx.pch' contains pre-compiled header
# 'stdafx.obj' to contain pre-compiled types
#stdafx.obj stdafx.pch: stdafx.h
#	$(CC) $(CPPFLAGS) /Ycstdafx.h /c stdafx.c

pch.obj pch.pch: pch.h
	$(CC) $(CPPFLAGS) /Ycpch.h /c pch.c

*.obj: pch.pch

# Note: no explicit dependency on resource.h
edline.obj: edline.h configdg.h mydde.h

configdg.obj: edline.h configdg.h

mydde.obj: edline.h mydde.h

clean:
	-erase $(EXE)
	-erase edline.res
	-erase pch.pch
	-erase edline.map
	-erase edline.sym
	-erase edline.pdb
	-erase *.obj

#############################################################################
